/*
 * ServiceLoggingAspectTest.java
 * Copyright (C) 2008 Cyber Beans Corporation. All rights reserved.
 */
package jp.co.cybec.cb3.aspect;

import java.io.StringWriter;

import jp.co.cybec.cb3.container.service.Service;
import jp.co.cybec.cb3.mock.container.service.MockService;
import jp.co.cybec.cb3.session.RuntimeParameters;
import jp.co.cybec.cb3.session.ServiceParameters;
import junit.framework.Assert;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.apache.log4j.WriterAppender;
import org.junit.Before;
import org.junit.Test;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * ServiceLoggingAspectのテストケース。
 * @author Naoko Sugimoto
 */
public class ServiceLoggingAspectTest {

	/** テスト用ログライター */
	private StringWriter logWriter = new StringWriter();

	/** アプリケーションコンテキスト */
	private ApplicationContext context = null;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {

		// 設定ファイル読み込み。
		context = new ClassPathXmlApplicationContext(
				new String[]{
						"jp/co/cybec/cb3/aspect/applicationContext.xml"
				}
		);

		// Loggerを作成
		Logger logger = Logger.getLogger(ServiceLoggingAspect.class);
		logger.setLevel(Level.INFO);

		// パターンを決定する
		PatternLayout layout = new PatternLayout("%m%n");
		WriterAppender appender = new WriterAppender(layout,logWriter);

		// Appenderを登録
		logger.addAppender(appender);
	}

	/**
	 * {@link jp.co.cybec.cb3.aspect.ServiceLoggingAspect#around(org.aspectj.lang.ProceedingJoinPoint)} のためのテスト・メソッド。
	 * 引数に渡されたジョイントポイントのサービスメソッドが実行され、戻り値が返されることを確認する。
	 * また、サービス用のトレースログが出力されていることを確認する。
	 */
	@Test
	public void testServiceAround() {
		String expectedStartMessage = "[" + MockService.class.getName() + "] サービスを開始します。";
		String expectedEndMessage = "[" + MockService.class.getName() + "] サービスを終了します。";

		// サービスを生成。
		Service service = (Service)context.getBean("testService");

		// サービスを実行し、戻り値が正しいことを確認する。
		int returnCode = service.callService(new ServiceParameters(), new RuntimeParameters(null));
		Assert.assertEquals(0, returnCode);

		// トレースログが出力されていることを確認する。
		StringBuffer logBuffer = logWriter.getBuffer();
		int startMessageIndex = logBuffer.indexOf(expectedStartMessage);
		Assert.assertTrue(startMessageIndex > -1);
		Assert.assertTrue(logBuffer.indexOf(expectedEndMessage) > startMessageIndex);
	}
}
